<template>
  <div class="dropdown" :class="{'active': isOpen, 'dropdown--center': isCenter && !isMobile}">
    <div @click="toggle"
         class="button dropdown__btn"
         :class="isBtnActive ? 'dropdown__btn--active' : ''"
    >
      <slot name="btn"></slot>
    </div>

    <div class="dropdown__body" ref="dropdownBody">
      <slot name="body"/>
    </div>
  </div>
</template>

<script>
  export default {
    name: "Dropdown",
    props: {
      isBtnActive: {
        type: Boolean,
        default: false
      }
    },

    data: () => ({
      isOpen: false,
      isCenter: false
    }),

    mounted() {
      document.addEventListener('click', (e) => {
        if (e.detail.needToClose || e.target.closest('.dropdown') !== this.$el)
          this.close();
      });

      if (this.isMobile) {
        this.setMobileLeftOffset()
      } else {
        this.$refs.dropdownBody.style.left = ``;
      }
    },

    computed: {
      isMobile() {
        return this.$store.state.isMobile;
      },
    },

    watch: {
      isMobile(val) {
        this.$nextTick(() => {
          if (val) {
            this.setMobileLeftOffset();
          } else {
            this.$refs.dropdownBody.style.left = ``;
          }
        });
      }
    },

    methods: {
      open() {
        this.setMobileLeftOffset();

        this.isOpen = true;
      },

      close() {
        this.isOpen = false;
      },

      toggle() {
        if (this.isMobile) {
          this.setMobileLeftOffset();
        }


        this.isOpen = !this.isOpen;
        this.isCenter = this.$el.parentElement.offsetLeft > 20;
      },

      setMobileLeftOffset() {
        const globalFZ = parseFloat(window.getComputedStyle(document.querySelector('html')).fontSize);
        const leftOffset = this.$el.getBoundingClientRect().left;
        const drBodyWidth = 360 / 16 * globalFZ;
        const resultOffset = leftOffset - (window.innerWidth - drBodyWidth) / 2;

        this.$refs.dropdownBody.style.left = `${ -(resultOffset / globalFZ) }rem`;
      },
    }
  }
</script>

<style lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .dropdown {
    position: relative;

    &.active {
      .dropdown {
        &__btn {
          @include gray-btn-active;
          color: $dark-gray;

          .dropdown__icon {
            transform: rotate(-180deg);
          }

          &--active {
            color: $black;
          }
        }

        &__body {
          display: block;
        }
      }
    }

    &__text-ellipsis {
      .dropdown__text {
        max-width: calc(100% - 1.75rem);
        overflow: hidden;
        text-overflow: ellipsis;
      }
    }

    &__btn {
      @include gray-btn;

      &:hover {
        color: $black;
      }

      &--active {
        padding-right: rem(18);
        color: $black;

        .dropdown__icon {
          flex: 0 0 rem(28);
          width: rem(28);
          height: rem(28);
          padding: rem(10);
          margin-left: 0;

          transition: none;
        }
      }

      height: rem(60);
      padding: 0 rem(30);

      font-weight: 600;
      font-size: rem(14);
      white-space: nowrap;
      color: $dark-gray;
    }

    &__icon-wrapper {
      display: flex;
    }

    &__icon {
      flex: 0 0 rem(8);
      width: rem(8);
      margin-left: rem(6);

      transform: rotate(0);
      transition: transform .35s;
    }

    &__symbol {
      line-height: 2;
    }

    &__body {
      display: none;

      position: absolute;
      z-index: 10;
      top: calc(100% + .625rem);

      width: rem(360);
      padding: rem(30);

      background: $light-gray;
      box-shadow: 0 rem(20) rem(30) rgba(24, 46, 68, 0.16);
      border-radius: rem(8);
    }

    &--center {
      .dropdown__body {
        left: 50%;
        transform: translateX(-50%);
      }
    }


  }
</style>
